/*
INTERACTIVE ----------------------------------------------------------------------------------------
Interactive helpers often with improved semantic names built on top of Bulma
*/

.is-interactive-navigation {
  color: $primary;
}

.button.is-interactive-navigation {
  background-color: $primary;
  border-color: transparent;
  color: $white;
  @extend .is-outlined;

  &.is-active,
  &:hover:not([disabled]) {
    background-color: darken($primary, 2.5%);
  }

  &.is-outlined {
    background-color: transparent;
    border-color: $primary;
    color: $primary;

    &.is-active,
    &:hover:not([disabled]) {
      background-color: $primary;
      border-color: transparent;
      color: $white;
    }
  }
}

.is-interactive-primary {
  @extend .is-success;
}

.is-interactive-secondary {
  @extend .is-info;
}

.has-text-interactive-primary {
  @extend .has-text-success;
}

.has-text-interactive-secondary {
  @extend .has-text-info;
}

.has-text-interactive-navigation {
  color: $primary;
}

a.disabled {
  pointer-events: none;
}

.disabled {
  cursor: not-allowed;
  color: #ccc;
  opacity: 0.7;
}

/*
COMPONENTS -----------------------------------------------------------------------------------------
Component helpers related to Bulma's component classes when bulma-overrides doesn't suffice
*/

.breadcrumb {
  margin-top: 0.75rem;
  margin-left: 1.25rem;

  &:not(:last-child) {
    margin-bottom: 0rem;
  }

  @media screen and (min-width: $tablet) {
    margin-left: 4.75rem;
  }
}

.navbar {
  // Fixes hover dropdown auto closing in navbar via https://github.com/jgthms/bulma/issues/2514#issuecomment-510451361
  @media screen and (min-width: 1025px) {
    .navbar-item.is-hoverable:hover .navbar-dropdown {
      display: block !important;
    }
    .navbar-item.is-hoverable:focus-within .navbar-dropdown {
      display: none;
    }
  }
}

.panel-block {
  &.is-active {
    color: $interactive-secondary;
    border-left-color: $interactive-secondary;
    border-left-width: 2px;
    @extend .has-background-white-ter;
  }
}

/*
LAYOUT ---------------------------------------------------------------------------------------------
Layout helpers, often with names based on Bulma naming conventions
*/

.view-body {
  border: 1px solid $grey-lighter;
  border-radius: $radius-large;
  background-color: $white-ter;
  padding: 1em;

  // Full view height - (navbar + breadcrumbs) - (.view-body top and bottom padding + extra padding to mitigate unwanted vertical scrollbar)
  min-height: calc(100vh - 72px - 3.25rem);

  &.is-fluid {
    margin-left: 0;
    margin-right: 0;
  }
}

.modal-card {
  overflow: visible; // Prevents clipping of dropdown and similar components in Modal

  &.is-narrow {
    max-width: 440px;
  }

  &.is-wide {
    width: calc(100vw - 160px);
  }

  .modal-card-head-image {
    margin-right: 1.25rem;
  }

  .modal-card-body {
    overflow: visible; // Prevents clipping of dropdown and similar components in Modal

    &.is-overflow-y-scroll {
      overflow-y: scroll;
    }
  }
}

.row-space-between {
  display: flex;
  flex-direction: row;
  align-items: center;

  .row-space-between-primary {
    flex-grow: 1;
  }
}

.step-spacer {
  margin: 0 0.2rem;
  font-style: italic;
}

.table td {
  vertical-align: middle;
}

.table th span {
  vertical-align: middle;
}

/*
MODIFIERS ------------------------------------------------------------------------------------------
Modifer helpers with names based on Bulma naming conventions
*/

.has-background-transparent {
  background-color: transparent;
}

.has-cursor-pointer {
  cursor: pointer;
}

.has-text-underlined {
  text-decoration: underline;
}

.is-borderless {
  border: none;
}

.is-flex-wrap {
  flex-wrap: wrap;
}

.is-flex-no-grow {
  flex-grow: 0;
}

.is-flex-column {
  flex-direction: column;
}

.is-flex-row {
  flex-direction: row;
}
